# Kernel in the Cloud
Kernel in the Cloud onboarding

## Version: 1

### Servers

| URL | Description |
| --- | ----------- |
| https://sandbox.api.visa.com | Sandbox server |

---
## KiC Terminal Profile
Service Providers could use this API to configure terminal profiles on iOS devices that accept payments using the Kernel in Cloud Solution.

### [POST] /vacservices/v1/ios/associate/terminalProfile
**Associate Terminal Profile**

This document defines APIs used by ServiceProviders/Apple Business Registry account holders to link the terminalProfileId generated by Apple to KernelProfileId generated in KiC.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"kernelTerminalMappingList"**: [ { **"kernelProfileId"**: string, **"ternminalProfileId"**: string } ] }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | successful operation |  |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [GET] /vacservices/v1/ios/terminalProfile/{kernelProfileId}
**Get Terminal Profile**

This document defines APIs used by ServiceProviders/ABR Account holders to get the TerminalProfile generated KiC. 
KiC generates the TerminalProfile in YAML format, This YAML is Base64Encoded and sent in Response. 
ServiceProviders can base64decode the response and upload the YAML to Apple Business Registry.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| kernelProfileId | path | Kernel Profile ID | Yes | string | No |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Response for Get Terminal Profile API | **application/json**: { **"kernelProfileId"**: string, **"ternminalProfile"**: string }<br> |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

---
## KiC Store Profile
Apis to create and update Store Profile

### [GET] /vacservices/v1/profile/merchant/{merchantProfileId}/store/{storeProfileId}
**Get Store Profile**

This API is for Providers to get StoreProfile created in KiC

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| merchantProfileId | path | Store profile id and merchant ID | Yes | string | simple | No |
| storeProfileId | path |  | Yes | string | simple | No |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | successful operation | **application/json**: { **"city"**: string, **"state"**: string, **"country"**: string, **"clientId"**: string, **"storeName"**: string, **"postalCode"**: string, **"addressLine"**: string, **"storeProfileId"**: string, **"storeProfileName"**: string, **"merchantProfileId"**: string }<br> |

### [PUT] /vacservices/v1/profile/merchant/{merchantProfileId}/store/{storeProfileId}
**Update Store Profile**

Store Profile Update.

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| merchantProfileId | path |  | Yes | string | simple | No |
| storeProfileId | path |  | Yes | string | simple | No |

#### Request Body

Store profile update request details

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"city"**: string, **"state"**: string, **"country"**: string, **"zipcode"**: string, **"storeName"**: string, **"addressLine"**: string }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 200 | successful operation |

### [DELETE] /vacservices/v1/profile/merchant/{merchantProfileId}/store/{storeProfileId}
**Delete Store Profile**

This API is for Providers to delete StoreProfile in KiC

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| merchantProfileId | path | Store profile id and merchant ID | Yes | string | simple | No |
| storeProfileId | path |  | Yes | string | simple | No |

#### Responses

| Code | Description |
| ---- | ----------- |
| 200 | successful operation |

### [POST] /vacservices/v1/profile/merchant/{merchantProfileId}/store
**Create Store Profile**

Store Profile Creation.

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| merchantProfileId | path |  | Yes | string | simple | No |

#### Request Body

Store profile creation request details

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"city"**: string, **"state"**: string, **"country"**: string, **"zipcode"**: string, **"storeName"**: string, **"addressLine"**: string, **"storeProfileName"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | created operation | **application/json**: { **"storeProfileId"**: string }<br> |

---
## KiC Kernel Profile
Apis to create,Update ProviderProfiles

### [PUT] /vacservices/v1/profile/kernel/{kernelProfileName}
**Kernel Profile Update**

Kernel Profile Update.

#### Parameters

| Name | Located in | Description | Required | Schema | Style | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ----- | ------- |
| kernelProfileName | path |  | Yes | string | simple | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"kernelConfig"**: { **"kernelConfigurationCDO"**: { **"qual"**: string, **"tmsid"**: string, **"lastUpdate"**: dateTime, **"scriptList"**: { **"scriptCDO"**: [ { **"script"**: string, **"dataStoreID"**: string } ] }, **"scriptFormat"**: string, **"scriptEncoding"**: string, **"configurationID"**: string, **"psconfigurationList"**: { **"psconfigurationCDO"**: [ { **"psid"**: string, **"lastUpdate"**: dateTime, **"psconfigurationID"**: string } ] } } } }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 202 | Accepted | **application/json**: { **"KernelProfileUpdateResponse"**: { **"version"**: integer } }<br> |

### [GET] /vacservices/v2/profile/kernel/{kernelProfileId}
**Get Kernel Profile**

This API is for Providers to get Kernel Profile created KiC.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| kernelProfileId | path | Kernel Profile ID | Yes | string | No |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Response for Update API | **application/json**: { **"version"**: string, **"KernelProfileRequestV2"**: { **"kernelProfileInfo"**: { **"countryCode"**: string, **"currencyCode"**: string, **"interfaceProfileList"**: [ { **"svIDProfileList"**: [ { **"svIDProfile"**: string, **"transactionTypeProfileList"**: [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"maximumLimit"**: string, **"kernelOptionList"**: [ string, <br>**Available values:** "AUCBypass", "EMVMode", "RRP" ], **"zeroAmountAction"**: string, <br>**Available values:** "Decline", "Online", "Allowed", **"cvmbelowLimitList"**: [ string ], **"maximumLimitODCVM"**: string, **"cvmatOrAboveLimitList"**: [ string ], **"tacdenialIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"taconlineIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionTypeProfile"**: string, <br>**Available values:** "Payment", "PaymentWithCashback", "Refund", "Cash", "CashBack", "ANY", **"tacdefaultIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionCategoryCode"**: string, **"terminalRiskManagementData"**: string, **"offlineOnlineCapabilityList"**: [ string, <br>**Available values:** "DeferredOnline", "Offline", "Online" ], **"additionalPaymentServiceList"**: [ string, <br>**Available values:** "Cashback", "Tip" ], **"applicationSelectionIndicator"**: string, <br>**Available values:** "Partial", "Full", **"offlineDataAuthenticationList"**: [ string, <br>**Available values:** "CDA" ] } ] } ], **"interfaceProfile"**: string, <br>**Available values:** "ANY", "Contact", "Contactless", "QR" } ], **"acceptanceEnvironmentCDO"**: { **"usageList"**: [ string, <br>**Available values:** "PartialApproval", "StatusCheck" ], **"terminalControl"**: string, <br>**Available values:** "Merchant", "FinancialInstitution", **"terminalAttended"**: string, <br>**Available values:** "Attended", "NonAttended" }, **"merchantPrioritySvIDList"**: [ string ] }, **"kernelProfileName"**: string } }<br> |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [PUT] /vacservices/v2/profile/kernel/{kernelProfileId}
**Update Kernel Profile**

This API is for Providers to update Kernel Profile in KiC.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| kernelProfileId | path | Kernel Profile ID | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"kernelProfileInfo"**: { **"countryCode"**: string, **"currencyCode"**: string, **"interfaceProfileList"**: [ { **"svIDProfileList"**: [ { **"svIDProfile"**: string, **"transactionTypeProfileList"**: [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"maximumLimit"**: string, **"kernelOptionList"**: [ string, <br>**Available values:** "AUCBypass", "EMVMode", "RRP" ], **"zeroAmountAction"**: string, <br>**Available values:** "Decline", "Online", "Allowed", **"cvmbelowLimitList"**: [ string ], **"maximumLimitODCVM"**: string, **"cvmatOrAboveLimitList"**: [ string ], **"tacdenialIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"taconlineIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionTypeProfile"**: string, <br>**Available values:** "Payment", "PaymentWithCashback", "Refund", "Cash", "CashBack", "ANY", **"tacdefaultIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionCategoryCode"**: string, **"terminalRiskManagementData"**: string, **"offlineOnlineCapabilityList"**: [ string, <br>**Available values:** "DeferredOnline", "Offline", "Online" ], **"additionalPaymentServiceList"**: [ string, <br>**Available values:** "Cashback", "Tip" ], **"applicationSelectionIndicator"**: string, <br>**Available values:** "Partial", "Full", **"offlineDataAuthenticationList"**: [ string, <br>**Available values:** "CDA" ] } ] } ], **"interfaceProfile"**: string, <br>**Available values:** "ANY", "Contact", "Contactless", "QR" } ], **"acceptanceEnvironmentCDO"**: { **"usageList"**: [ string, <br>**Available values:** "PartialApproval", "StatusCheck" ], **"terminalControl"**: string, <br>**Available values:** "Merchant", "FinancialInstitution", **"terminalAttended"**: string, <br>**Available values:** "Attended", "NonAttended" }, **"merchantPrioritySvIDList"**: [ string ] } }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Response for Update API | **application/json**: { **"version"**: integer }<br> |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [DELETE] /vacservices/v2/profile/kernel/{kernelProfileId}
**Delete Kernel Profile**

This API is for Providers to delete Kernel Profile in KiC.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| kernelProfileId | path | Kernel Profile ID | Yes | string | No |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | OK |  |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [GET] /vacservices/v2/profile/kernel/{kernelProfileId}/{version}
**Get Kernel profile by Version**

This API is for Providers to get Kernel Profile created in VAC.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| kernelProfileId | path | Kernel Profile ID | Yes | string | No |
| version | path | Kernel Profile Version (If no value sent current active version of Kernel Profile would be returned) | Yes | integer | No |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Response for Update API | **application/json**: { **"version"**: string, **"KernelProfileRequestV2"**: { **"kernelProfileInfo"**: { **"countryCode"**: string, **"currencyCode"**: string, **"interfaceProfileList"**: [ { **"svIDProfileList"**: [ { **"svIDProfile"**: string, **"transactionTypeProfileList"**: [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"maximumLimit"**: string, **"kernelOptionList"**: [ string, <br>**Available values:** "AUCBypass", "EMVMode", "RRP" ], **"zeroAmountAction"**: string, <br>**Available values:** "Decline", "Online", "Allowed", **"cvmbelowLimitList"**: [ string ], **"maximumLimitODCVM"**: string, **"cvmatOrAboveLimitList"**: [ string ], **"tacdenialIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"taconlineIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionTypeProfile"**: string, <br>**Available values:** "Payment", "PaymentWithCashback", "Refund", "Cash", "CashBack", "ANY", **"tacdefaultIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionCategoryCode"**: string, **"terminalRiskManagementData"**: string, **"offlineOnlineCapabilityList"**: [ string, <br>**Available values:** "DeferredOnline", "Offline", "Online" ], **"additionalPaymentServiceList"**: [ string, <br>**Available values:** "Cashback", "Tip" ], **"applicationSelectionIndicator"**: string, <br>**Available values:** "Partial", "Full", **"offlineDataAuthenticationList"**: [ string, <br>**Available values:** "CDA" ] } ] } ], **"interfaceProfile"**: string, <br>**Available values:** "ANY", "Contact", "Contactless" } ], **"acceptanceEnvironmentCDO"**: { **"usageList"**: [ string, <br>**Available values:** "PartialApproval", "StatusCheck" ], **"terminalControl"**: string, <br>**Available values:** "Merchant", "FinancialInstitution", **"terminalAttended"**: string, <br>**Available values:** "Attended", "NonAttended" }, **"merchantPrioritySvIDList"**: [ string ] }, **"kernelProfileName"**: string } }<br> |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [POST] /vacservices/v2/profile/kernel
**Create Kernel Profile**

Kernel Profile Creation Version 2.0.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"kernelProfileInfo"**: { **"countryCode"**: string, **"currencyCode"**: string, **"storeAndForwardCDO"**: { **"maximumCumulativeAmount"**: string, **"maximumTransactionNumber"**: string }, **"interfaceProfileList"**: [ { **"svIDProfileList"**: [ { **"svIDProfile"**: string, <br>**Available values:** "PayByLink", **"firstGenVersionNumber"**: string, **"transactionTypeProfileList"**: [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"maximumLimit"**: string, **"kernelOptionList"**: [ string, <br>**Available values:** "AUCBypass", "EMVMode", "RRP", "TearingRecovery" ], **"zeroAmountAction"**: string, <br>**Available values:** "Decline", "Online", "Allowed", **"cvmbelowLimitList"**: [ string ], **"maximumLimitODCVM"**: string, **"cvmatOrAboveLimitList"**: [ string ], **"tacdenialIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1" ], **"taconlineIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1" ], **"transactionTypeProfile"**: string, <br>**Available values:** "Payment", "PaymentWithCashback", "Refund", "SAFPayment", "SAFRefund", "ANY", **"tacdefaultIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1" ], **"transactionCategoryCode"**: string, **"additionalCurrencyCodeList"**: [ string ], **"terminalRiskManagementData"**: string, **"additionalCurrencyLimitList"**: [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"currencyCode"**: string, **"maximumLimit"**: string, **"maximumLimitODCVM"**: string } ], **"offlineOnlineCapabilityList"**: [ string, <br>**Available values:** "DeferredOnline", "Offline", "Online" ], **"additionalPaymentServiceList"**: [ string, <br>**Available values:** "Cashback", "Tip" ], **"applicationSelectionIndicator"**: string, <br>**Available values:** "Partial", "Full", **"offlineDataAuthenticationList"**: [ string, <br>**Available values:** "CDA", "DDA" ] } ] } ], **"interfaceProfile"**: string, <br>**Available values:** "ANY", "Contact", "Contactless", "QR" } ], **"acceptanceEnvironmentCDO"**: { **"usageList"**: [ string, <br>**Available values:** "PartialApproval", "SCA", "StatusCheck" ], **"tcTypeList"**: [ string, <br>**Available values:** "iFON" ], **"terminalControl"**: string, <br>**Available values:** "Merchant", "FinancialInstitution", **"terminalAttended"**: string, <br>**Available values:** "Attended", "NonAttended" }, **"merchantPrioritySvIDList"**: [ string ] }, **"kernelProfileName"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Response for Create API | **application/json**: { **"kernelProfileId"**: string }<br> |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 409 | Record Conflict error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [POST] /vacservices/v1/profile/kernel
**Create Kernel Profile**

Kernel Profile Creation.

#### Request Body

KernelProfileCreation request details

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"kernelConfig"**: { **"kernelConfigurationCDO"**: { **"qual"**: string, **"tmsid"**: string, **"lastUpdate"**: dateTime, **"scriptList"**: { **"scriptCDO"**: [ { **"script"**: string, **"dataStoreID"**: string } ] }, **"scriptFormat"**: string, **"scriptEncoding"**: string, **"configurationID"**: string, **"psconfigurationList"**: { **"psconfigurationCDO"**: [ { **"psid"**: string, **"lastUpdate"**: dateTime, **"psconfigurationID"**: string } ] } } }, **"kernelProfileName"**: string }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 201 | successful operation |
| default | successful operation |

### [POST] /vacservices/v2/profile/kernel/{kernelProfileId}/revert/{version}
**Revert Kernel Profile**

This API is for Providers to Revert Kernel Profile to older specific version.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| kernelProfileId | path | Kernel Profile ID | Yes | string | No |
| version | path | Kernel Profile Version | Yes | integer | No |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Response for Update API | **application/json**: { **"version"**: integer }<br> |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

---
## KiC Merchant Profile
Apis to create,Update MerchantProfiles

### [POST] /vacservices/v1/profile/merchant
**Create Merchant Profile**

Merchant Profile Creation.

#### Request Body

MerchantProfileCreation request details

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"routingConfig"**: [ { **"processor"**: string, **"merchantId"**: string } ], **"merchantProfileName"**: string }<br> |

#### Responses

| Code | Description |
| ---- | ----------- |
| 201 | successful operation |
| default | successful operation |

### [GET] /vacservices/v2/profile/merchant/{merchantProfileId}
**Get Merchant Profile**

This API is for Providers to get MerchantProfile created in KiC

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| merchantProfileId | path | MerchantProfileId | Yes | string | No |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Response for Create API | **application/json**: { **"routingConfig"**: [ { **"processor"**: string, **"merchantId"**: string, **"merchantCategoryCode"**: string } ], **"merchantProfileName"**: string }<br> |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [PUT] /vacservices/v2/profile/merchant/{merchantProfileId}
**Update Merchant Profile**

This API is for Providers to update MerchantProfile in KiC

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| merchantProfileId | path | MerchantProfileId | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"routingConfig"**: [ { **"processor"**: string, **"merchantId"**: string, **"merchantCategoryCode"**: string } ] }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | successful operation |  |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [DELETE] /vacservices/v2/profile/merchant/{merchantProfileId}
**Delete Merchant Profile**

This API is for Providers to delete MerchantProfile in KiC

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| merchantProfileId | path | MerchantProfileId | Yes | string | No |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | successful operation |  |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [POST] /vacservices/v2/profile/merchant
**Create Merchant Profile**

Merchant Profile Creation.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"routingConfig"**: [ { **"processor"**: string, **"merchantId"**: string, **"merchantBannerName"**: string, **"merchantCategoryCode"**: string } ], **"merchantProfileName"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Response for Create API | **application/json**: { **"merchantProfileId"**: string }<br> |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 409 | Record Conflict error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

---
## KiC List
KiC List

### [GET] /vacservices/v1/list/retrieve/{reportGuid}/{reportId}
**Retrieve List**

Used to request a single page of a report of Stores/Devices.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| reportGuid | path |  | Yes | string | No |
| reportId | path |  | Yes | integer | No |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Retrieve Device/Store Data | **application/json**: { **"_links"**: { **"next"**: { **"href"**: string (uri) }, **"self"**: { **"href"**: string (uri) } }, **"content"**: { **"stores"**: [ { **"status"**: string, **"storeProfileId"**: string, **"statusChangeDateTime"**: string } ], **"devices"**: [ { **"status"**: string, **"vacDeviceId"**: string, **"storeProfileId"**: string, **"kernelProfileId"**: string, **"merchantProfile"**: string, **"statusChangeDateTime"**: string } ] } }<br> |
| 404 | When any field validation fails or when any required field is missing or when request is inconsistent with the Request definitions. | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: , **"status"**: , **"message"**:  } }<br> |

### [POST] /vacservices/v1/list/device
**Device List**

Clients can call this API to fetch a list of device that are onboarded to VAC by sending in the search criteria through request body.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"status"**: [ string, <br>**Available values:** "Active", "Disabled", "Deleted" ], **"endDate"**: dateTime, **"startDate"**: dateTime, **"recordsPerPage"**: integer, **"storeProfileIds"**: [ string ], **"kernelProfileIds"**: [ string ], **"merchantProfileIds"**: [ string ] }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 202 | Device/Store search report response | **application/json**: { **"reportLocation"**: string }<br> |
| 400 | When any field validation fails or when any required field is missing or when request is inconsistent with the Request definitions. | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: , **"status"**: , **"message"**:  } }<br> |

### [POST] /vacservices/v1/list/stores
**Store List**

Clients can call this API to fetch a list of stores that are onboarded to VAC by sending in the search criteria through request body.

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"status"**: [ string, <br>**Available values:** "Active", "InActive" ], **"endDate"**: dateTime, **"startDate"**: dateTime, **"recordsPerPage"**: integer, **"merchantProfileIds"**: [ string ] }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 202 | Device/Store search report response | **application/json**: { **"reportLocation"**: string }<br> |
| 400 | When any field validation fails or when any required field is missing or when request is inconsistent with the Request definitions. | **application/json**: { **"errorResponse"**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } } & { **"errorResponse"**: { **"reason"**: , **"status"**: , **"message"**:  } }<br> |

---
## KiC Device Enrollment
Api to enroll a device

### [POST] /vacservices/v2/device/{vacDeviceId}/manage
**Device Management**

This API is for Providers to Delete(permanently), Disable(temporarily) and Enable Devices that are enrolled in KiC

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| vacDeviceId | path | VAC Generated Device Id | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"action"**: string, <br>**Available values:** "disable", "enable", "delete" }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | successful operation |  |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [POST] /vacservices/v2/device/enroll
**Device Enrollment**

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"deviceInfo"**: { **"id"**: string, **"model"**: string, **"osType"**: string, **"manufacturer"**: string }, **"storeProfileId"**: string, **"kernelProfileId"**: string, **"cryptographicKeys"**: { **"deviceCerts"**: [ string ], **"serviceKeys"**: [ { **"keyFun"**: string, <br>**Available values:** "AUTHENTICITY", "KEY_AGREEMENT", **"keyRef"**: { **"x"**: string, **"y"**: string, **"crv"**: string, **"kid"**: string, **"kty"**: string, <br>**Available values:** "EC", **"use"**: string, <br>**Available values:** "ENC", "SIG" } } ] } }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Response for Enroll Device API | **application/json**: { **"deviceKeys"**: [ { **"key"**: { **"x"**: string, **"y"**: string, **"crv"**: string, **"kid"**: string, **"kty"**: string, <br>**Available values:** "EC", **"use"**: string, <br>**Available values:** "ENC", "SIG" }, **"keyFun"**: string, <br>**Available values:** "AUTHENTICITY", "KEY_AGREEMENT" } ], **"vacDeviceId"**: string }<br> |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 409 | Record Conflict error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [POST] /vacservices/v1/device/enroll
**Device Enrollment**

Device enrollment

#### Request Body

Device enrollment request details

| Required | Schema |
| -------- | ------ |
|  Yes | **application/json**: { **"deviceInfo"**: { **"id"**: string, **"model"**: string, **"osType"**: string, **"manufacturer"**: string }, **"cryptographicKeys"**: { **"deviceKeys"**: [ { **"key"**: { **"x"**: string, **"y"**: string, **"crv"**: string, **"kid"**: string, **"kty"**: string, <br>**Available values:** "EC", **"use"**: string, <br>**Available values:** "ENC", "SIG" }, **"keyFun"**: string, <br>**Available values:** "AUTHENTICITY", "KEY_AGREEMENT" } ], **"serviceKeys"**: [ { **"keyFun"**: string, <br>**Available values:** "AUTHENTICITY", "KEY_AGREEMENT", **"keyRef"**: { **"x"**: string, **"y"**: string, **"crv"**: string, **"kid"**: string, **"kty"**: string, <br>**Available values:** "EC", **"use"**: string, <br>**Available values:** "ENC", "SIG" } } ] }, **"kernelProfileName"**: string, **"merchantProfileName"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 201 | Created | **application/json**: { **"DeviceEnrollmentResponse"**: { **"deviceKeys"**: [ { **"key"**: { **"x"**: string, **"y"**: string, **"crv"**: string, **"kid"**: string, **"kty"**: string, <br>**Available values:** "EC", **"use"**: string, <br>**Available values:** "ENC", "SIG" }, **"keyFun"**: string, <br>**Available values:** "AUTHENTICITY", "KEY_AGREEMENT" } ], **"vacDeviceId"**: string } }<br> |

### [GET] /vacservices/v2/device/{vacDeviceId}
**Get Profiles From Device**

This API is used get the Kernel Profile Id and Store Profile Id associated to VacDeviceId in URI.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| vacDeviceId | path | VAC Generated Device Id | Yes | string | No |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | Response for Enroll Device API | **application/json**: { **"status"**: string, **"deviceInfo"**: { **"id"**: string, **"model"**: string, **"osType"**: string, **"manufacturer"**: string }, **"storeProfileId"**: string, **"kernelProfileId"**: string }<br> |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [PUT] /vacservices/v2/device/{vacDeviceId}
**Update Device **

This API is For Providers to update Device Enrollment in KiC

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| vacDeviceId | path | VAC Generated Device Id | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"storeProfileId"**: string, **"kernelProfileId"**: string }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | successful operation |  |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

---
## KiC Reconfigure
KiC Reconfigure

### [POST] /vacservices/v1/reconfig/merchant/{merchantProfileId}/stores
**Reconfigure Merchant Profile**

This API is to facilitate clients to switch a subset of Stores and its associated Devices to different Merchant.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| merchantProfileId | path | Merchant Profile Id | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"stores"**: [ string ], **"instruction"**: string, <br>**Available values:** "All", "AvailableOnly" }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | successful operation |  |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [POST] /vacservices/v1/reconfig/merchant/{merchantProfileId}/store/{storeProfileId}/devices
**Reconfigure Store Profile**

This API is to facilitate clients to associate a list of devices to different Stores. A Store can have more than one device, Clients can use this API to move a set of devices between stores at different location.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| merchantProfileId | path | Merchant Profile Id | Yes | string | No |
| storeProfileId | path | Store Profile Id | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"devices"**: [ string ], **"instruction"**: string, <br>**Available values:** "All", "AvailableOnly" }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | successful operation |  |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

### [POST] /vacservices/v1/reconfig/kernel/{kernelProfileId}/devices
**Reconfigure Kernel Profile**

This API is to facilitate client to switch a list of devices to new Kernel Profile. Single Kernel Profile can be shared by more than one Device, Any update to Kernel Profile would affect all the devices associated to it. Clients can use this API to break that dependency.

#### Parameters

| Name | Located in | Description | Required | Schema | Explode |
| ---- | ---------- | ----------- | -------- | ------ | ------- |
| kernelProfileId | path | VAC generated Kernel Profile Id | Yes | string | No |

#### Request Body

| Required | Schema |
| -------- | ------ |
|  No | **application/json**: { **"devices"**: [ string ], **"instruction"**: string, <br>**Available values:** "All", "AvailableOnly" }<br> |

#### Responses

| Code | Description | Schema |
| ---- | ----------- | ------ |
| 200 | successful operation |  |
| 400 | Field/Parameter Vaildation Error. | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 401 | Unauthorized |  |
| 404 | No data found Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |
| 500 | Unknown Server Error | **application/json**: { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } & { **"reason"**: , **"status"**: , **"message"**:  }<br> |

---
### Schemas

#### InterfaceProfileCDO-3 Schema

Identifies InterfaceProfile defined for each InterfaceID.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| svIDProfileList | [ { **"svIDProfile"**: string, **"transactionTypeProfileList"**: [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"maximumLimit"**: string, **"kernelOptionList"**: [ string, <br>**Available values:** "AUCBypass", "EMVMode", "RRP" ], **"zeroAmountAction"**: string, <br>**Available values:** "Decline", "Online", "Allowed", **"cvmbelowLimitList"**: [ string ], **"maximumLimitODCVM"**: string, **"cvmatOrAboveLimitList"**: [ string ], **"tacdenialIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"taconlineIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionTypeProfile"**: string, <br>**Available values:** "Payment", "PaymentWithCashback", "Refund", "Cash", "CashBack", "ANY", **"tacdefaultIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionCategoryCode"**: string, **"terminalRiskManagementData"**: string, **"offlineOnlineCapabilityList"**: [ string, <br>**Available values:** "DeferredOnline", "Offline", "Online" ], **"additionalPaymentServiceList"**: [ string, <br>**Available values:** "Cashback", "Tip" ], **"applicationSelectionIndicator"**: string, <br>**Available values:** "Partial", "Full", **"offlineDataAuthenticationList"**: [ string, <br>**Available values:** "CDA" ] } ] } ] | Identifies List of SvIDProfileCDO supported by Kernel for each InterfaceId in InterfaceProfileList. | Yes |
| interfaceProfile | string, <br>**Available values:** "ANY", "Contact", "Contactless", "QR" | Identifies InterfaceID supported by Kernel.  Validation rules: * Each Interface profile should be supported by the Configuration Management System or should be set to ‘ANY’. * Interface profile cannot have duplicates. * At least 1 Interface profile other than ‘ANY’ must be defined.   Possible values: * `ANY` - To support all interface types to perform transaction. * `Contact` - For Contact interface type to perform transaction. * `Contactless` - For Contactless interface type to perform transaction, for prod only Contactless is supported. * `QR` - For QR interface type to perform transaction. <br>*Enum:* `"ANY"`, `"Contact"`, `"Contactless"`, `"QR"` | Yes |

#### TerminalProfileMappingRequest-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| KernelTerminalMappingList | [ { **"kernelProfileId"**: string, **"ternminalProfileId"**: string } ] |  | Yes |

#### InterfaceProfileCDO-2 Schema

Identifies InterfaceProfile defined for each InterfaceID.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| svIDProfileList | [ { **"svIDProfile"**: string, <br>**Available values:** "PayByLink", **"firstGenVersionNumber"**: string, **"transactionTypeProfileList"**: [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"maximumLimit"**: string, **"kernelOptionList"**: [ string, <br>**Available values:** "AUCBypass", "EMVMode", "RRP", "TearingRecovery" ], **"zeroAmountAction"**: string, <br>**Available values:** "Decline", "Online", "Allowed", **"cvmbelowLimitList"**: [ string ], **"maximumLimitODCVM"**: string, **"cvmatOrAboveLimitList"**: [ string ], **"tacdenialIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1" ], **"taconlineIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1" ], **"transactionTypeProfile"**: string, <br>**Available values:** "Payment", "PaymentWithCashback", "Refund", "SAFPayment", "SAFRefund", "ANY", **"tacdefaultIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1" ], **"transactionCategoryCode"**: string, **"additionalCurrencyCodeList"**: [ string ], **"terminalRiskManagementData"**: string, **"additionalCurrencyLimitList"**: [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"currencyCode"**: string, **"maximumLimit"**: string, **"maximumLimitODCVM"**: string } ], **"offlineOnlineCapabilityList"**: [ string, <br>**Available values:** "DeferredOnline", "Offline", "Online" ], **"additionalPaymentServiceList"**: [ string, <br>**Available values:** "Cashback", "Tip" ], **"applicationSelectionIndicator"**: string, <br>**Available values:** "Partial", "Full", **"offlineDataAuthenticationList"**: [ string, <br>**Available values:** "CDA", "DDA" ] } ] } ] | Identifies List of SvIDProfileCDO supported by Kernel for each InterfaceId in InterfaceProfileList. | Yes |
| interfaceProfile | string, <br>**Available values:** "ANY", "Contact", "Contactless", "QR" | Identifies InterfaceID supported by Kernel.  Validation rules: * Each Interface profile should be supported by the Configuration Management System or should be set to ‘ANY’. * Interface profile cannot have duplicates. * At least 1 Interface profile other than ‘ANY’ must be defined.   Possible values: * `ANY` - To support all interface types to perform transaction. * `Contact` - For Contact interface type to perform transaction. * `Contactless` - For Contactless interface type to perform transaction, for prod only Contactless is supported. * `QR` - For QR interface type to perform transaction. <br>*Enum:* `"ANY"`, `"Contact"`, `"Contactless"`, `"QR"` | Yes |

#### InterfaceProfileCDO-1 Schema

Identifies InterfaceProfile defined for each InterfaceID.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| svIDProfileList | [ { **"svIDProfile"**: string, **"transactionTypeProfileList"**: [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"maximumLimit"**: string, **"kernelOptionList"**: [ string, <br>**Available values:** "AUCBypass", "EMVMode", "RRP" ], **"zeroAmountAction"**: string, <br>**Available values:** "Decline", "Online", "Allowed", **"cvmbelowLimitList"**: [ string ], **"maximumLimitODCVM"**: string, **"cvmatOrAboveLimitList"**: [ string ], **"tacdenialIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"taconlineIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionTypeProfile"**: string, <br>**Available values:** "Payment", "PaymentWithCashback", "Refund", "Cash", "CashBack", "ANY", **"tacdefaultIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionCategoryCode"**: string, **"terminalRiskManagementData"**: string, **"offlineOnlineCapabilityList"**: [ string, <br>**Available values:** "DeferredOnline", "Offline", "Online" ], **"additionalPaymentServiceList"**: [ string, <br>**Available values:** "Cashback", "Tip" ], **"applicationSelectionIndicator"**: string, <br>**Available values:** "Partial", "Full", **"offlineDataAuthenticationList"**: [ string, <br>**Available values:** "CDA" ] } ] } ] | Identifies List of SvIDProfileCDO supported by Kernel for each InterfaceId in InterfaceProfileList. | Yes |
| interfaceProfile | string, <br>**Available values:** "ANY", "Contact", "Contactless" | Identifies InterfaceID supported by Kernel. Possible values: * `ANY` - To support all interface types to perform transaction. * `Contact` - For Contact interface type to perform transaction. * `Contactless` - For Contactless interface type to perform transaction, for prod only Contactless is supported. <br>*Enum:* `"ANY"`, `"Contact"`, `"Contactless"` | Yes |

#### ServiceKey Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| keyFun | string, <br>**Available values:** "AUTHENTICITY", "KEY_AGREEMENT" | *Enum:* `"AUTHENTICITY"`, `"KEY_AGREEMENT"` | Yes |
| keyRef | { **"x"**: string, **"y"**: string, **"crv"**: string, **"kid"**: string, **"kty"**: string, <br>**Available values:** "EC", **"use"**: string, <br>**Available values:** "ENC", "SIG" } |  | Yes |

#### DeviceEnrollmentUpdateRequestV2 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| storeProfileId | string | Store associated to this Device. | No |
| kernelProfileId | string | KernelConfiguration to be used by device for transaction processing | No |

#### SvIDProfileCDO Schema

Identifies SvIDProfile defined for each SvID supported by the Kernel.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| svIDProfile | string | Identifies SvID supported by the Kernel. It indicates AID(supports single Application for a Payment System) or RID(supports multiple Application for a Payment System) or US Common Debit. Currently MasterCard and Visa are supported. | Yes |
| transactionTypeProfileList | [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"maximumLimit"**: string, **"kernelOptionList"**: [ string, <br>**Available values:** "AUCBypass", "EMVMode", "RRP" ], **"zeroAmountAction"**: string, <br>**Available values:** "Decline", "Online", "Allowed", **"cvmbelowLimitList"**: [ string ], **"maximumLimitODCVM"**: string, **"cvmatOrAboveLimitList"**: [ string ], **"tacdenialIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"taconlineIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionTypeProfile"**: string, <br>**Available values:** "Payment", "PaymentWithCashback", "Refund", "Cash", "CashBack", "ANY", **"tacdefaultIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionCategoryCode"**: string, **"terminalRiskManagementData"**: string, **"offlineOnlineCapabilityList"**: [ string, <br>**Available values:** "DeferredOnline", "Offline", "Online" ], **"additionalPaymentServiceList"**: [ string, <br>**Available values:** "Cashback", "Tip" ], **"applicationSelectionIndicator"**: string, <br>**Available values:** "Partial", "Full", **"offlineDataAuthenticationList"**: [ string, <br>**Available values:** "CDA" ] } ] | Identifies List of TransactionProfile supported by the Kernel for each SvIDProfile in svIDProfileList. | No |

#### DateTime Schema

A date or date with GMT time. If only date is provided, the time will default to 00:00:00.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| DateTime | dateTime | A date or date with GMT time. If only date is provided, the time will default to 00:00:00. |  |

#### TACIndicator-2 Schema

1st Gen Terminal Action Code – Online, Varies per Transaction Type,
per SvID, Not Applicable for ContactLess InterfaceID.

Validation rules:
* Should contain valid Terminal Action Codes.

Possible values:
  * `ODANotPerformed` - Offline data authentication was not performed(Byte1bit8)
  * `SDAFailed` - SDA failed(Byte1bit7)
  * `ICCDataMissing` - ICC data missing(Byte1bit6)
  * `ExceptionFile` - Card appears on terminal exception file(Byte1bit5)  
  * `DDAFailed` - DDA failed(Byte1bit4)
  * `CDAFailed` - CDA failed(Byte1bit3)
  * `RFUByte1bit1` - RFU(Byte1bit1)
  * `VersionMismatch` - ICC and terminal have different application versions(Byte2bit8)
  * `Expired` - Expired application(Byte2bit7)
  * `NotYetEffective` - Application not yet effective(Byte2bit6)
  * `ServiceNotAllowed` - Requested service not allowed for card product(Byte2bit5)
  * `NewCard` - New Card(Byte2bit4)
  * `RFUByte2bit3` - RFU(Byte2bit3)
  * `CVNotSuccessful` - Cardholder verification was not successful(Byte3bit8)
  * `CVMUnknown` - Unrecognised CVM(Byte3bit7)
  * `PINTryExeceeded` - PIN Try Limit exceeded(Byte3bit6)
  * `PEDMalfunction` - PIN entry required and PIN pad not present or not working(Byte3bit5)
  * `PINBypassed` - PIN entry required, PIN pad present, but PIN was not entered(Byte3bit4)
  * `OnlineCVM` - OnlinePINentered(Byte3bit3)
  * `BEDMalfunction/RFUByte3bit2` - RFU(Byte3bit2)
  * `FloorLimitExceeded` - Transaction exceeds floor limit(Byte4bit8)
  * `LCOLExceeded` - Lower consecutive offline limit exceeded(Byte4bit7)
  * `UCOLExceeded` - Upper consecutive offline limit exceeded(Byte4bit6)
  * `RandomOnline` - Transaction  selected randomly for online processing(Byte4bit5)
  * `ForcedOnline` - Merchant forced transaction online(Byte4bit4)
  * `RFUByte4bit1` - RFU(Byte4bit1)
  * `TDOL` - Default TDOL used(Byte5bit8)
  * `IssuerAuthenticationFailed` - Issuer authentication failed(Byte5bit7)
  * `ScriptFailureBeforeGenAC` - Script processing failed before final GENERATE AC(Byte5bit6)
  * `ScriptFailureAfterGenAC` - Script processing failed after final GENERATE AC(Byte5bit5)
  * `RRPThresholdExceeded/RFUByte5bit4` - RRPThresholdExceeded apply to Mastercard only. RFU(Byte5bit4)
  * `RRPTimeExceeded/RFUByte5bit3` - RRPTimeExceeded apply to Mastercard only. RFU(Byte5bit3) 
  * `RRPPerformed/RFUByte5bit2` - RRPPerformed apply to Mastercard only. RFU(Byte5bit2) 
  * `RRPNotPerformed/RFUByte5bit1` - RRPNotPerformed apply to Mastercard only. RFU(Byte5bit1) 

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| TACIndicator-2 | [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ] | 1st Gen Terminal Action Code – Online, Varies per Transaction Type, per SvID, Not Applicable for ContactLess InterfaceID.  Validation rules: * Should contain valid Terminal Action Codes.   Possible values:   * `ODANotPerformed` - Offline data authentication was not performed(Byte1bit8)   * `SDAFailed` - SDA failed(Byte1bit7)   * `ICCDataMissing` - ICC data missing(Byte1bit6)   * `ExceptionFile` - Card appears on terminal exception file(Byte1bit5)     * `DDAFailed` - DDA failed(Byte1bit4)   * `CDAFailed` - CDA failed(Byte1bit3)   * `RFUByte1bit1` - RFU(Byte1bit1)   * `VersionMismatch` - ICC and terminal have different application versions(Byte2bit8)   * `Expired` - Expired application(Byte2bit7)   * `NotYetEffective` - Application not yet effective(Byte2bit6)   * `ServiceNotAllowed` - Requested service not allowed for card product(Byte2bit5)   * `NewCard` - New Card(Byte2bit4)   * `RFUByte2bit3` - RFU(Byte2bit3)   * `CVNotSuccessful` - Cardholder verification was not successful(Byte3bit8)   * `CVMUnknown` - Unrecognised CVM(Byte3bit7)   * `PINTryExeceeded` - PIN Try Limit exceeded(Byte3bit6)   * `PEDMalfunction` - PIN entry required and PIN pad not present or not working(Byte3bit5)   * `PINBypassed` - PIN entry required, PIN pad present, but PIN was not entered(Byte3bit4)   * `OnlineCVM` - OnlinePINentered(Byte3bit3)   * `BEDMalfunction/RFUByte3bit2` - RFU(Byte3bit2)   * `FloorLimitExceeded` - Transaction exceeds floor limit(Byte4bit8)   * `LCOLExceeded` - Lower consecutive offline limit exceeded(Byte4bit7)   * `UCOLExceeded` - Upper consecutive offline limit exceeded(Byte4bit6)   * `RandomOnline` - Transaction  selected randomly for online processing(Byte4bit5)   * `ForcedOnline` - Merchant forced transaction online(Byte4bit4)   * `RFUByte4bit1` - RFU(Byte4bit1)   * `TDOL` - Default TDOL used(Byte5bit8)   * `IssuerAuthenticationFailed` - Issuer authentication failed(Byte5bit7)   * `ScriptFailureBeforeGenAC` - Script processing failed before final GENERATE AC(Byte5bit6)   * `ScriptFailureAfterGenAC` - Script processing failed after final GENERATE AC(Byte5bit5)   * `RRPThresholdExceeded/RFUByte5bit4` - RRPThresholdExceeded apply to Mastercard only. RFU(Byte5bit4)   * `RRPTimeExceeded/RFUByte5bit3` - RRPTimeExceeded apply to Mastercard only. RFU(Byte5bit3)    * `RRPPerformed/RFUByte5bit2` - RRPPerformed apply to Mastercard only. RFU(Byte5bit2)    * `RRPNotPerformed/RFUByte5bit1` - RRPNotPerformed apply to Mastercard only. RFU(Byte5bit1)   |  |

#### TACIndicator-1 Schema

1st Gen Terminal Action Code – Online, Varies per Transaction Type,
per SvID, Not Applicable for ContactLess InterfaceID.

Validation rules:
* Should contain valid Terminal Action Codes.

Possible values:
  * `ODANotPerformed` - Offline data authentication was not performed(Byte1bit8)
  * `SDAFailed` - SDA failed(Byte1bit7)
  * `ICCDataMissing` - ICC data missing(Byte1bit6)
  * `ExceptionFile` - Card appears on terminal exception file(Byte1bit5)  
  * `DDAFailed` - DDA failed(Byte1bit4)
  * `CDAFailed` - CDA failed(Byte1bit3)
  * `RFUByte1bit1` - RFU(Byte1bit1)
  * `VersionMismatch` - ICC and terminal have different application versions(Byte2bit8)
  * `Expired` - Expired application(Byte2bit7)
  * `NotYetEffective` - Application not yet effective(Byte2bit6)
  * `ServiceNotAllowed` - Requested service not allowed for card product(Byte2bit5)
  * `NewCard` - New Card(Byte2bit4)
  * `RFUByte2bit3` - RFU(Byte2bit3)
  * `CVNotSuccessful` - Cardholder verification was not successful(Byte3bit8)
  * `CVMUnknown` - Unrecognised CVM(Byte3bit7)
  * `PINTryExeceeded` - PIN Try Limit exceeded(Byte3bit6)
  * `PEDMalfunction` - PIN entry required and PIN pad not present or not working(Byte3bit5)
  * `PINBypassed` - PIN entry required, PIN pad present, but PIN was not entered(Byte3bit4)
  * `OnlineCVM` - OnlinePINentered(Byte3bit3)
  * `BEDMalfunction/RFUByte3bit2` - RFU(Byte3bit2)
  * `FloorLimitExceeded` - Transaction exceeds floor limit(Byte4bit8)
  * `LCOLExceeded` - Lower consecutive offline limit exceeded(Byte4bit7)
  * `UCOLExceeded` - Upper consecutive offline limit exceeded(Byte4bit6)
  * `RandomOnline` - Transaction  selected randomly for online processing(Byte4bit5)
  * `ForcedOnline` - Merchant forced transaction online(Byte4bit4)
  * `RFUByte4bit1` - RFU(Byte4bit1)
  * `TDOL` - Default TDOL used(Byte5bit8)
  * `IssuerAuthenticationFailed` - Issuer authentication failed(Byte5bit7)
  * `ScriptFailureBeforeGenAC` - Script processing failed before final GENERATE AC(Byte5bit6)
  * `ScriptFailureAfterGenAC` - Script processing failed after final GENERATE AC(Byte5bit5)
  * `RRPThresholdExceeded/RFUByte5bit4` - RRPThresholdExceeded apply to Mastercard only. RFU(Byte5bit4)
  * `RRPTimeExceeded/RFUByte5bit3` - RRPTimeExceeded apply to Mastercard only. RFU(Byte5bit3) 
  * `RRPPerformed/RFUByte5bit2` - RRPPerformed apply to Mastercard only. RFU(Byte5bit2) 
  * `RRPNotPerformed/RFUByte5bit1` - RRPNotPerformed apply to Mastercard only. RFU(Byte5bit1) 

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| TACIndicator-1 | [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1" ] | 1st Gen Terminal Action Code – Online, Varies per Transaction Type, per SvID, Not Applicable for ContactLess InterfaceID.  Validation rules: * Should contain valid Terminal Action Codes.   Possible values:   * `ODANotPerformed` - Offline data authentication was not performed(Byte1bit8)   * `SDAFailed` - SDA failed(Byte1bit7)   * `ICCDataMissing` - ICC data missing(Byte1bit6)   * `ExceptionFile` - Card appears on terminal exception file(Byte1bit5)     * `DDAFailed` - DDA failed(Byte1bit4)   * `CDAFailed` - CDA failed(Byte1bit3)   * `RFUByte1bit1` - RFU(Byte1bit1)   * `VersionMismatch` - ICC and terminal have different application versions(Byte2bit8)   * `Expired` - Expired application(Byte2bit7)   * `NotYetEffective` - Application not yet effective(Byte2bit6)   * `ServiceNotAllowed` - Requested service not allowed for card product(Byte2bit5)   * `NewCard` - New Card(Byte2bit4)   * `RFUByte2bit3` - RFU(Byte2bit3)   * `CVNotSuccessful` - Cardholder verification was not successful(Byte3bit8)   * `CVMUnknown` - Unrecognised CVM(Byte3bit7)   * `PINTryExeceeded` - PIN Try Limit exceeded(Byte3bit6)   * `PEDMalfunction` - PIN entry required and PIN pad not present or not working(Byte3bit5)   * `PINBypassed` - PIN entry required, PIN pad present, but PIN was not entered(Byte3bit4)   * `OnlineCVM` - OnlinePINentered(Byte3bit3)   * `BEDMalfunction/RFUByte3bit2` - RFU(Byte3bit2)   * `FloorLimitExceeded` - Transaction exceeds floor limit(Byte4bit8)   * `LCOLExceeded` - Lower consecutive offline limit exceeded(Byte4bit7)   * `UCOLExceeded` - Upper consecutive offline limit exceeded(Byte4bit6)   * `RandomOnline` - Transaction  selected randomly for online processing(Byte4bit5)   * `ForcedOnline` - Merchant forced transaction online(Byte4bit4)   * `RFUByte4bit1` - RFU(Byte4bit1)   * `TDOL` - Default TDOL used(Byte5bit8)   * `IssuerAuthenticationFailed` - Issuer authentication failed(Byte5bit7)   * `ScriptFailureBeforeGenAC` - Script processing failed before final GENERATE AC(Byte5bit6)   * `ScriptFailureAfterGenAC` - Script processing failed after final GENERATE AC(Byte5bit5)   * `RRPThresholdExceeded/RFUByte5bit4` - RRPThresholdExceeded apply to Mastercard only. RFU(Byte5bit4)   * `RRPTimeExceeded/RFUByte5bit3` - RRPTimeExceeded apply to Mastercard only. RFU(Byte5bit3)    * `RRPPerformed/RFUByte5bit2` - RRPPerformed apply to Mastercard only. RFU(Byte5bit2)    * `RRPNotPerformed/RFUByte5bit1` - RRPNotPerformed apply to Mastercard only. RFU(Byte5bit1)   |  |

#### DeviceInfo Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| id | string | Unique DeviceId generated in Acquirer/PSP Payment Gateway, This is treated as TerminalId in VAC.<br>*Example:* `"3424bd66-1ed2-9h21-4fg61"` | Yes |
| model | string | Device Model. | No |
| osType | string | OSType on Device. | No |
| manufacturer | string | Device Manufacturer. | No |

#### StoreDataList Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| stores | [ string ] | No more than 200 Stores in a single Request | Yes |
| instruction | string, <br>**Available values:** "All", "AvailableOnly" | Instruction indicates the action to be performed on the DeviceList          Possible values: * `All` - This action will instruct VAC to consider the all devices sent in Request to update, If Unknown/Deleted/Disabled devices found in request, API Errors out. * `AvailableOnly` - This action will instruct VAC to ignore any Unknown/Deleted/Disabled devices and update only the available devices. <br>*Enum:* `"All"`, `"AvailableOnly"` | Yes |

#### KernelProfileRequestV2-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| kernelProfileInfo | { **"countryCode"**: string, **"currencyCode"**: string, **"interfaceProfileList"**: [ { **"svIDProfileList"**: [ { **"svIDProfile"**: string, **"transactionTypeProfileList"**: [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"maximumLimit"**: string, **"kernelOptionList"**: [ string, <br>**Available values:** "AUCBypass", "EMVMode", "RRP" ], **"zeroAmountAction"**: string, <br>**Available values:** "Decline", "Online", "Allowed", **"cvmbelowLimitList"**: [ string ], **"maximumLimitODCVM"**: string, **"cvmatOrAboveLimitList"**: [ string ], **"tacdenialIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"taconlineIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionTypeProfile"**: string, <br>**Available values:** "Payment", "PaymentWithCashback", "Refund", "Cash", "CashBack", "ANY", **"tacdefaultIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionCategoryCode"**: string, **"terminalRiskManagementData"**: string, **"offlineOnlineCapabilityList"**: [ string, <br>**Available values:** "DeferredOnline", "Offline", "Online" ], **"additionalPaymentServiceList"**: [ string, <br>**Available values:** "Cashback", "Tip" ], **"applicationSelectionIndicator"**: string, <br>**Available values:** "Partial", "Full", **"offlineDataAuthenticationList"**: [ string, <br>**Available values:** "CDA" ] } ] } ], **"interfaceProfile"**: string, <br>**Available values:** "ANY", "Contact", "Contactless" } ], **"acceptanceEnvironmentCDO"**: { **"usageList"**: [ string, <br>**Available values:** "PartialApproval", "StatusCheck" ], **"terminalControl"**: string, <br>**Available values:** "Merchant", "FinancialInstitution", **"terminalAttended"**: string, <br>**Available values:** "Attended", "NonAttended" }, **"merchantPrioritySvIDList"**: [ string ] } |  | Yes |
| kernelProfileName | string | Identifies the name defined for the KernelConfig by Providers and should be unique. | Yes |

#### StoreProfileCreateRequest-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| city | string |  | Yes |
| state | string |  | Yes |
| country | string |  | Yes |
| zipcode | string |  | Yes |
| storeName | string |  | Yes |
| addressLine | string |  | Yes |
| storeProfileName | string |  | Yes |

#### KernelProfileRequestV2-4 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| kernelProfileInfo | { **"countryCode"**: string, **"currencyCode"**: string, **"interfaceProfileList"**: [ { **"svIDProfileList"**: [ { **"svIDProfile"**: string, **"transactionTypeProfileList"**: [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"maximumLimit"**: string, **"kernelOptionList"**: [ string, <br>**Available values:** "AUCBypass", "EMVMode", "RRP" ], **"zeroAmountAction"**: string, <br>**Available values:** "Decline", "Online", "Allowed", **"cvmbelowLimitList"**: [ string ], **"maximumLimitODCVM"**: string, **"cvmatOrAboveLimitList"**: [ string ], **"tacdenialIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"taconlineIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionTypeProfile"**: string, <br>**Available values:** "Payment", "PaymentWithCashback", "Refund", "Cash", "CashBack", "ANY", **"tacdefaultIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1", "RRPNotSupported" ], **"transactionCategoryCode"**: string, **"terminalRiskManagementData"**: string, **"offlineOnlineCapabilityList"**: [ string, <br>**Available values:** "DeferredOnline", "Offline", "Online" ], **"additionalPaymentServiceList"**: [ string, <br>**Available values:** "Cashback", "Tip" ], **"applicationSelectionIndicator"**: string, <br>**Available values:** "Partial", "Full", **"offlineDataAuthenticationList"**: [ string, <br>**Available values:** "CDA" ] } ] } ], **"interfaceProfile"**: string, <br>**Available values:** "ANY", "Contact", "Contactless", "QR" } ], **"acceptanceEnvironmentCDO"**: { **"usageList"**: [ string, <br>**Available values:** "PartialApproval", "StatusCheck" ], **"terminalControl"**: string, <br>**Available values:** "Merchant", "FinancialInstitution", **"terminalAttended"**: string, <br>**Available values:** "Attended", "NonAttended" }, **"merchantPrioritySvIDList"**: [ string ] } |  | Yes |
| kernelProfileName | string | Identifies the name defined for the KernelConfig by Providers and should be unique. | Yes |

#### KernelProfileRequestV2-2 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| kernelProfileInfo | { **"countryCode"**: string, **"currencyCode"**: string, **"storeAndForwardCDO"**: { **"maximumCumulativeAmount"**: string, **"maximumTransactionNumber"**: string }, **"interfaceProfileList"**: [ { **"svIDProfileList"**: [ { **"svIDProfile"**: string, <br>**Available values:** "PayByLink", **"firstGenVersionNumber"**: string, **"transactionTypeProfileList"**: [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"maximumLimit"**: string, **"kernelOptionList"**: [ string, <br>**Available values:** "AUCBypass", "EMVMode", "RRP", "TearingRecovery" ], **"zeroAmountAction"**: string, <br>**Available values:** "Decline", "Online", "Allowed", **"cvmbelowLimitList"**: [ string ], **"maximumLimitODCVM"**: string, **"cvmatOrAboveLimitList"**: [ string ], **"tacdenialIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1" ], **"taconlineIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1" ], **"transactionTypeProfile"**: string, <br>**Available values:** "Payment", "PaymentWithCashback", "Refund", "SAFPayment", "SAFRefund", "ANY", **"tacdefaultIndicatorList"**: [ string, <br>**Available values:** "ODANotPerformed", "SDAFailed", "ICCDataMissing", "ExceptionFile", "DDAFailed", "CDAFailed", "RFUByte1bit1", "VersionMismatch", "Expired", "NotYetEffective", "ServiceNotAllowed", "NewCard", "RFUByte2bit3", "CVNotSuccessful", "CVMUnknown", "PINTryExeceeded", "PEDMalfunction", "PINBypassed", "OnlineCVM", "BEDMalfunction/RFUByte3bit2", "FloorLimitExceeded", "LCOLExceeded", "UCOLExceeded", "RandomOnline", "ForcedOnline", "RFUByte4bit1", "TDOL", "IssuerAuthenticationFailed", "ScriptFailureBeforeGenAC", "ScriptFailureAfterGenAC", "RRPThresholdExceeded/RFUByte5bit4", "RRPTimeExceeded/RFUByte5bit3", "RRPPerformed/RFUByte5bit2", "RRPNotPerformed/RFUByte5bit1" ], **"transactionCategoryCode"**: string, **"additionalCurrencyCodeList"**: [ string ], **"terminalRiskManagementData"**: string, **"additionalCurrencyLimitList"**: [ { **"cvmlimit"**: string, **"floorLimit"**: string, **"currencyCode"**: string, **"maximumLimit"**: string, **"maximumLimitODCVM"**: string } ], **"offlineOnlineCapabilityList"**: [ string, <br>**Available values:** "DeferredOnline", "Offline", "Online" ], **"additionalPaymentServiceList"**: [ string, <br>**Available values:** "Cashback", "Tip" ], **"applicationSelectionIndicator"**: string, <br>**Available values:** "Partial", "Full", **"offlineDataAuthenticationList"**: [ string, <br>**Available values:** "CDA", "DDA" ] } ] } ], **"interfaceProfile"**: string, <br>**Available values:** "ANY", "Contact", "Contactless", "QR" } ], **"acceptanceEnvironmentCDO"**: { **"usageList"**: [ string, <br>**Available values:** "PartialApproval", "SCA", "StatusCheck" ], **"tcTypeList"**: [ string, <br>**Available values:** "iFON" ], **"terminalControl"**: string, <br>**Available values:** "Merchant", "FinancialInstitution", **"terminalAttended"**: string, <br>**Available values:** "Attended", "NonAttended" }, **"merchantPrioritySvIDList"**: [ string ] } |  | Yes |
| kernelProfileName | string | Identifies the name defined for the KernelConfig by Providers and should be unique. | Yes |

#### ErrorResponse-1 Schema

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
| errorResponse | { **"reason"**: string, **"status"**: integer, **"details"**: [ { **"message"**: string, **"location"**: string } ], **"message"**: string } |  | No |

#### AcceptanceEnvironmentCDO Schema

Identifies the AcceptanceEnvironment supported by Kernel.

| Name | Type | Description | Required |
| ---- | ---- | ----------- | -------- |
[...]
